package org.steveshipway.cheshirecat;

import java.util.Iterator;
import java.util.Random;
 





import org.steveshipway.cheshirecat.lib.Constants;

import net.minecraft.block.Block;
import net.minecraft.init.Blocks;
import net.minecraft.util.ChunkCoordinates;
import net.minecraft.world.World;
import net.minecraft.world.biome.BiomeGenBase;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraft.world.gen.feature.WorldGenMinable;
import cpw.mods.fml.common.IWorldGenerator;
	 
public class AutoGenerator implements IWorldGenerator
{
	@Override
	public void generate(Random random, int chunkX, int chunkZ, World world, IChunkProvider chunkGenerator, IChunkProvider chunkProvider)
	{
		Blueprint bp = null;
		String bpName = null;
		ChunkCoordinates location = new ChunkCoordinates();
		int r;
		Block blk;
		if( ! CheshireCat.enableAutoGen ) { return; } // autogen is disabled globally
		if( world.isRemote ) { return; } // should never happen, but just in case
		
		// world.provider.dimensionId => [ -1, 0, 1 ]
        BiomeGenBase b = world.getBiomeGenForCoords(chunkX,chunkZ);
        // now, loop through all known structures, and search for one with Auto enabled, that is randomly selected, and matches this biome.
        Iterator i = CheshireCat.portfolio.auto_iterator();
        while( i.hasNext() ) {
        	bpName = (String) i.next(); 
        	bp = CheshireCat.portfolio.blueprint(bpName);
        	//CheshireCat.logger.info("Testing plan "+bpName+" for chance "+bp.auto_chance+"/"+Constants.CHANCE_BASE);
        	if( bp.auto_chance == 0 ) { continue; }              // not auto-enabled
        	//CheshireCat.logger.info("Testing auto-plan "+bpName+" for chance "+bp.auto_chance+"/"+Constants.CHANCE_BASE);
        	if( random.nextInt(Constants.CHANCE_BASE) > bp.auto_chance ) { continue; } // not randomly selected
        	//CheshireCat.logger.info("Checking biome list for "+bpName+ " against "+b.biomeName);
        	if( !bp.biomes.contains(b.biomeName) && !bp.biomes.contains("Any")) { continue; } // not matching biome name
        	// can we probe the chunk for torches and doors (the presence of which would indicate existing structures)?
        	// we're doing this one!
        	r = random.nextInt(4);
        	location.posX = random.nextInt(16) + ( chunkX * 16 );
        	location.posZ = random.nextInt(16) + ( chunkZ * 16 );
        	location.posY = world.getHeightValue(location.posX, location.posZ);
    		// float up if underground
    		while( location.posY < 128 && world.getBlock(location.posX, location.posY, location.posZ) != Blocks.air 
    				&& world.getBlock(location.posX, location.posY, location.posZ) != Blocks.water ) {
    			location.posY += 1; 
    		}
        	// sink to ground if in the air
        	blk =  world.getBlock(location.posX, location.posY-1, location.posZ);
    		while( location.posY > 0 && (blk == Blocks.air || blk == Blocks.water 
    			|| blk == Blocks.leaves || blk == Blocks.leaves2 || blk == Blocks.log || blk == Blocks.log2 
    		) ) {
    			location.posY -= 1;
            	blk =  world.getBlock(location.posX, location.posY-1, location.posZ);
    		}

        	CheshireCat.logger.info("Autogenerating a "+bpName+ " at "+location.posX+","+location.posY+","+location.posZ+" rot="+r);
        	bp.build(world, location, r);
        	break; // only one structure per chunk
        }
	}
	
}
