package org.steveshipway.cheshirecat.directive;

import java.util.Random;

import net.minecraft.util.ChunkCoordinates;
import net.minecraft.world.World;

import org.steveshipway.cheshirecat.CheshireCat;

public class ChanceDirective extends Directive {
	private int percentage = 0;
	private Directive directive = null;
	
	public ChanceDirective(int chance, Directive d) {
		percentage = chance;
		directive = d;
		if( d == null ) {
    		CheshireCat.logger.error("No secondary directive given to CHANCE directive");
			return;
		}
		if( chance < 0 || chance > 100 ) {
    		CheshireCat.logger.error("Invalid percentage "+chance+" given to CHANCE directive");
			return;
		}
	}
	
	@Override
	public boolean build(World world,ChunkCoordinates location, int r) {
		Random rnd = new Random();
		if( directive == null ) {
    		CheshireCat.logger.error("No secondary directive given to CHANCE directive");
			return false;
		}
		if( rnd.nextInt(100) < this.percentage ) {
			return directive.build(world,location,r);
		} else {
			return true;
		}
	}
	
	@Override
	public String asText() {
		if( directive == null) {
			return "# CHANCE 0";
		} else {
			return "CHANCE "+percentage+"\n  "+directive.asText();
		}
	}
}
