package org.steveshipway.cheshirecat.directive;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.steveshipway.cheshirecat.CheshireCat;

public class AutoDirective extends Directive {
	public Set biomes = new HashSet();
	
	public AutoDirective(String definition) {
    	Pattern p = Pattern.compile("(?i)^(?:\\s*auto)\\s*(\\d+)%?\\s*(.*)");
    	Matcher m = p.matcher(definition);
    	if( m.find() ) {
    		try {
	    		this.auto_chance = Integer.parseInt(m.group(1));
	    	    for (String retval: m.group(2).split("\\s*,+\\s*")){
	    	          biomes.add(retval);
	    	    }
    		} catch( Exception e ) {
        		CheshireCat.logger.error("Bad Auto definition: "+definition);    			
    		}
    	} else {
    		CheshireCat.logger.error("Bad Auto definition: "+definition);
    	}
	}
	
	@Override
	public String asText() {
		if( this.auto_chance > 0 ) {
			String s = "AUTO "+this.auto_chance+" ";
			Iterator i = biomes.iterator();
			while( i.hasNext())  {
				s = s + " " + i.next();
			}
			return s;
		} else {
			return "# AUTO undefined";
		}
	}
}
