package org.steveshipway.cheshirecat.directive;

import java.util.regex.Matcher;
import java.util.regex.Pattern;


import org.steveshipway.cheshirecat.CheshireCat;

public class DescDirective extends Directive {
	public DescDirective(String definition) {
    	Pattern p = Pattern.compile("(?i)^(?:\\s*desc(?:ription))\\s*(\\w.*)");
    	Matcher m = p.matcher(definition);
    	if( m.find() ) {
    		this.description = m.group(1);
    	} else {
    		CheshireCat.logger.error("Bad description definition: "+definition);
    	}
	}
	
	@Override
	public String asText() {
		if( this.description != null ) {
			return "DESCRIPTION "+this.description;
		} else {
			return "# DESCRIPTION";
		}
	}
}
