package org.steveshipway.cheshirecat.directive;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.steveshipway.cheshirecat.CheshireCat;

public class OptionDirective extends Directive {
	public OptionDirective(String definition) {
    	Pattern p = Pattern.compile("(?i)^(?:\\s*option)\\s*(\\w+)");
    	Matcher m = p.matcher(definition);
    	if( m.find() ) {
    		this.option = m.group(1); 
    	} else {
    		CheshireCat.logger.error("Bad option definition: "+definition);
    	}
	}
	
	@Override
	public String asText() {
		if( this.option != null ) {
			return "OPTION "+this.option;
		} else {
			return "# OPTION undefined";
		}
	}
}
